<?php defined('SYSPATH') or die('No direct script access.');
 
class Controller_UserEnvi extends Controller {
    protected $UserInfo;
    protected $SemesterInfo;

    public function before()
    {
        $user = User::instance();
        if(!$user->isSignedIn()) {
            $this->redirect('sign', 302);
            return;
        } 
        $this->UserInfo = $user->getInfoAsArray();

        $db = new Model_Student;
        $semester = $db->getSemesterInfo($this->UserInfo['SemesterID']);
        // $semester['Num'] = $semester['Num'] == 1 ? 'Осень' : 'Весна';
        if($semester['Num'] == 1)
        {
            $semester['Num'] = 'Осень';
        }
        else
        {
            $semester['Num'] = 'Весна';
            $semester['Year']++;
        }
        $this->SemesterInfo = $semester;

        if($this->UserInfo['Type'] == 'student') {
            //unified degree from db
            $uniDegree = $this->UserInfo['Degree'];
            $this->UserInfo['Degree'] = Model_Grades::getDegreeTitle($uniDegree);
        }
        // Проверка на доступ к странице
        $route = Route::name($this->request->route());
        $userMark = $user->offsetGet('RoleMark');
        $sysModel = new Model_System;
        $bitmask = (int)$sysModel->getBitmaskForRoute($route);
        if ($bitmask === 0) {
            $bitmask = (int)1;
        }
        if ($userMark === 0) {
            $userMark = (int)1;
        }
        if(!($bitmask & $userMark)) {
            throw HTTP_Exception::factory(403, 
            'Не пытайтесь попасть туда, куда попадать не следует.');
        }
    }
    
    public function action_index()
    {
        $type = $this->UserInfo['Type'];
        $page = Request::factory($type.'/index')->execute();
        $this->response->body($page);
    }
    
    public function action_profile()
    {
        if($this->UserInfo['Type'] != 'teacher') {
            $this->redirect('/', 302);
        } else {
            $url = "teacher/profile";
            $page = Request::factory($url)->execute();
            $this->response->body($page);
        }
    }
	
    public function action_settings()
    {
        $page = Request::factory($this->UserInfo['Type'].'/settings')->execute();
        $this->response->body($page);
    }
}
